//<!--<OWENSKIP/>-->
var nvar = 5;							// 
var nfan = 6;							// 
var nname = nvar + nfan;				// 

var names  = new Array (nname);			//  
var vars   = new Array (nvar);			//  
var grvars = new Array (nvar);			//  
var txvars = new Array (nvar);			//   
var fans   = new Array (nfan);			//  
var grfans = new Array (nfan);			//  
var txfans = new Array (nfan);			//   

var tvars = -1;							//  

var nc=0								//  
var grcircle = new Array (600);			//  

var newtime = 0;						// 
var oldtime = 0;						// 
var newH = 0;							// 
var oldH = 0;							// 
var newM = 0;							// 
var oldM = 0;							// 
var newS = 0;							// 
var oldS = 0;							// 
var interval = 5;	 					//   

var svgNS = "http://www.w3.org/2000/svg";
var documentSVG = null;
var chartGroup = null;
var updateInterval = 500; 
var x = 50, y = 50;
var height = 300, width = 600;
var xt1 = 0, yt1 = -100;
var xt2 = 600, yt2 = 100;
var ti = 0;								//   
var xDivisions = 10, yDivisions = 20;
var defaultTextWidth = 30, defaultTextHeight = 20; 
var xIndexes = new Array(xDivisions + 1);
var yIndexes = new Array(yDivisions + 1);
var currentNodeInfo;
var lastX = -1, lastY = -1;
var chartGroup, dataGroup, dataPath;


function init(evt) 
{
	documentSVG = evt.target.ownerDocument;
	chartGroup = documentSVG.createElementNS(svgNS, "g");
	chartGroup.setAttribute("transform", "translate(" + x + " " + y + ")");

	axisGroup = documentSVG.createElementNS(svgNS, "g");
	axisPath = documentSVG.createElementNS(svgNS, "path");
	axisPath.setAttribute("stroke", "black"); 
	axisPath.setAttribute("stroke-width", "2");

	pathText = "M 0 " + height; 
	for (var i = 0; i <= xDivisions; i++) 
		pathText += "l 0 5 l 0 -5 " + ((i == xDivisions) ? "" : ("l " + width/xDivisions + " 0"));
	pathText += "M 0 " + height;
	for (var i = 0; i <= yDivisions; i++)
		pathText += "l -5 0 l 5 0 " + ((i == yDivisions) ? "" : ("l 0 -" + height / yDivisions)); 
	axisPath.setAttribute("d", pathText); 
	axisGroup.appendChild(axisPath);
//----------------------------------------------------------------
	oldtime = new Date();
	oldH = oldtime.getHours();
	oldM = oldtime.getMinutes();
	oldS = oldtime.getSeconds();
//----------------------------------------------------------------
	if ((oldM + xt2/60)<=60)
	{
		for (var i = 0; i <= xDivisions; i++)
		{
			t = documentSVG.createElementNS(svgNS, "text");
			xIndexes[i] = t;
			t.appendChild(documentSVG.createTextNode((oldH+":"+(oldM+i))));
			t.setAttribute("x", i * width / xDivisions - defaultTextWidth / 2);
			t.setAttribute("y", height + 10 + defaultTextHeight); 
			t.setAttribute("stroke", "black"); 
			axisGroup.appendChild(t);
		}
	}
	else
	{
		for (var i = 0; i < (60-oldM); i++)
		{
			t = documentSVG.createElementNS(svgNS, "text");
			xIndexes[i] = t;
			t.appendChild(documentSVG.createTextNode((oldH+":"+(oldM+i))));
			t.setAttribute("x", i * width / xDivisions - defaultTextWidth / 2);
			t.setAttribute("y", height + 10 + defaultTextHeight); 
			t.setAttribute("stroke", "black"); 
			axisGroup.appendChild(t);
		}
		if(oldH!=23)
		{
			for (var i = (60-oldM); i <= xDivisions; i++)
			{
				t = documentSVG.createElementNS(svgNS, "text");
				xIndexes[i] = t;
				t.appendChild(documentSVG.createTextNode((oldH+1+":"+(i-(60-oldM)))));
				t.setAttribute("x", i * width / xDivisions - defaultTextWidth / 2);
				t.setAttribute("y", height + 10 + defaultTextHeight); 
				t.setAttribute("stroke", "black"); 
				axisGroup.appendChild(t);
			}
		}
		else
		{
			for (var i = (60-oldM); i <= xDivisions; i++)
			{
				t = documentSVG.createElementNS(svgNS, "text");
				xIndexes[i] = t;
				t.appendChild(documentSVG.createTextNode(("0:"+(i-(60-oldM)))));
				t.setAttribute("x", i * width / xDivisions - defaultTextWidth / 2);
				t.setAttribute("y", height + 10 + defaultTextHeight); 
				t.setAttribute("stroke", "black"); 
				axisGroup.appendChild(t);
			}
		}
	}

	for (var i = 0; i <= yDivisions; i++)
	{
		t = documentSVG.createElementNS(svgNS, "text");
		yIndexes[i] = t;
		t.appendChild(documentSVG.createTextNode((yt1 + i * ((yt2 - yt1) / yDivisions)))); 
		t.setAttribute("x", -10 -defaultTextWidth);
		t.setAttribute("y", height - i * height / yDivisions + defaultTextHeight / 2 - 5); 
		t.setAttribute("stroke", "black");  
		axisGroup.appendChild(t);
	}

	chartGroup.appendChild(axisGroup);

	dataPath = documentSVG.createElementNS(svgNS, "path"); 
	dataPath.setAttribute("stroke", "black");
	dataPath.setAttribute("stroke-width", "1");
	dataPath.setAttribute("fill", "none");
	chartGroup.appendChild(dataPath);
//--------------------------------------------------------
	for (var i = 0; i < nvar; i++)
	{
		grvars[i] = documentSVG.createElementNS(svgNS, "circle"); 
		grvars[i].setAttribute("cx", 30+i*120);
		grvars[i].setAttribute("cy", -20);
		grvars[i].setAttribute("r", 6);
		grvars[i].setAttribute("onclick", "setvar(" + i + ")");
		chartGroup.appendChild(grvars[i]);
	}
	setvar(0);
	for (var i = 0; i < nvar; i++)
	{ 
		txvars[i] = documentSVG.createElementNS(svgNS, "text");
		txvars[i].appendChild(documentSVG.createTextNode(""));
		txvars[i].setAttribute("x", 40+i*120);
		txvars[i].setAttribute("y",-15); 
		axisGroup.appendChild(txvars[i]);
	}
	for (var i = 0; i < nfan; i++)
	{
		grfans[i] = documentSVG.createElementNS(svgNS, "circle"); 
		grfans[i].setAttribute("cx", 610);
		grfans[i].setAttribute("cy", 5+i*40);
		grfans[i].setAttribute("r", 6);
		chartGroup.appendChild(grfans[i]);
	}
	for (var i = 0; i < nfan; i++)
	{ 
		txfans[i] = documentSVG.createElementNS(svgNS, "text");
		txfans[i].appendChild(documentSVG.createTextNode(""));
		txfans[i].setAttribute("x", 610 + 10);
		txfans[i].setAttribute("y", 10+i*40); 
		axisGroup.appendChild(txfans[i]);
	}
//--------------------------------------------------------
	documentSVG.documentElement.appendChild(chartGroup);
	setTimeout("updateChart()", updateInterval);
}


function createPointInfo(x, y, whereX, whereY,t1,t2,t3) 
{
	if (currentNodeInfo) removePointInfo();
	currentNodeInfo = documentSVG.createElementNS(svgNS, "text");
	//currentNodeInfo.appendChild(documentSVG.createTextNode("("+x+","+y+")"));
	currentNodeInfo.setAttribute("stroke", "green");
	currentNodeInfo.appendChild(documentSVG.createTextNode(t1 + ":" +t2 + ":" + t3 + " ; "+y));
	currentNodeInfo.setAttribute("x", whereX.toFixed(1));
	currentNodeInfo.setAttribute("y", whereY - 10);
	chartGroup.appendChild(currentNodeInfo);
}


function removePointInfo()
{
	chartGroup.removeChild(currentNodeInfo);
	currentNodeInfo = null;
}


function addPoint(X, Y) 
{
	if ((X >= 0) && ( X <= 10) && (nc+2>X))
		remove();
	if(X!= lastX)
	{
		lastX = X;
		lastY = Y;
		if (X == xt2)
			window.location.reload(false);
		coordX = (X - xt1) * (width / (xt2 - xt1));  
		coordY = height - (Y - yt1) * (height / (yt2 - yt1));
		grcircle[nc] = documentSVG.createElementNS(svgNS, "circle"); 
		grcircle[nc].setAttribute("cx", coordX);
		grcircle[nc].setAttribute("cy", coordY);
		grcircle[nc].setAttribute("r", 3);
		grcircle[nc].setAttribute("fill", "blue"); 
		grcircle[nc].setAttribute("onmouseover", "createPointInfo(" + X + "," + Y + "," + coordX + "," + coordY + "," + newH + "," + newM + "," + newS + ")");
		grcircle[nc].setAttribute("onmouseout", "removePointInfo()");
		chartGroup.appendChild(grcircle[nc]);
		nc++;
		current = dataPath.getAttribute("d"); 
		if (!current || current == "")
			dataPath.setAttribute("d", " M " + coordX + " " + coordY);  
		else
			dataPath.setAttribute("d", current + " L " + coordX + " " + coordY);
	}
}


function updateChart()
{
	newtime = new Date();
	newH = newtime.getHours();
	newM = newtime.getMinutes();
	newS = newtime.getSeconds();
	if ((newH==0) && (oldH==23))
	{
		oldtime=newtime;
		oldH=newH;
		oldM=newM;
		oldS=newS;
		remove(); 
	}
			  
	if ( ((newH*3600 + newM *60 + newS) - (oldH*3600 + oldM*60 + oldS)) >= interval)
	{
		if (window.getURL)
			getURL("param.txt", handleResults);
		else
			ajaxRequest("param.txt", handleResults);
	}
	else
		setTimeout("updateChart()", updateInterval);
}

function handleResults(data) 
{
	if (window.getURL)
		responseText = data.content;
	else
		responseText = data; 
	var newParam = responseText.split(",");
	
	for (var i = 0; i < (nname + nvar + nfan); i++)
	{
		if ( i<nname )
			names[i] = newParam[i];
		if ( i< (nname + nvar) )
			vars[i-nname] = newParam[i];
		if ( i < (nname + nvar + nfan) )
			fans[i - nname - nvar] = newParam[i];
	}
	
	//-----------------------------------------------------
	/*	vars[0]=Math.sin(newS * 1.66666666666)*100;
		vars[1]=Math.sin(newS * 1.66666666666)*80;
		vars[2]=Math.sin(newS * 1.66666666666)*10;
		vars[3]=Math.sin(-newS * 1.66666666666)*50;
		vars[4]=Math.sin(-newS * 1.66666666666)*100;*/
	//-----------------------------------------------------
	
	for (var i = 0; i < nvar; i++)
	{
		axisGroup.removeChild(txvars[i]);
		txvars[i] = documentSVG.createElementNS(svgNS, "text");
		txvars[i].appendChild(documentSVG.createTextNode(names[i]));
		txvars[i].setAttribute("x", 40+i*120);
		txvars[i].setAttribute("y",-15); 
		axisGroup.appendChild(txvars[i]);
		grvars[i].setAttribute("onmouseover", "createvarInfo(" + (20+i*120) + "," + (-30) + "," + i + ")");
		grvars[i].setAttribute("onmouseout", "removePointInfo()");
	}
	for (var i = 0; i < nfan; i++)
	{ 
		axisGroup.removeChild(txfans[i]);
		txfans[i] = documentSVG.createElementNS(svgNS, "text");
		txfans[i].appendChild(documentSVG.createTextNode(names[i+nvar]));
		txfans[i].setAttribute("x", 610 + 10);
		txfans[i].setAttribute("y", 10+i*40); 
		axisGroup.appendChild(txfans[i]);
		if (fans[i] == "FALSE")
			grfans[i].setAttribute("fill", "red");
		if (fans[i] == "TRUE")
			grfans[i].setAttribute("fill", "green");
		grfans[i].setAttribute("onmouseover", "createfanInfo(" + 600 + "," + (-10+i*40) + "," + i + ")");
		grfans[i].setAttribute("onmouseout", "removePointInfo()");
	}
	var t;
	if (oldM == newM)
	{
		t= ti*60 + newS;
	}
	else
	{
		ti++;
		if (ti<(xt2/60))
			t= ti*60 + newS;
		else
		{
			ti=0;
			t= ti*60 + newS;
		}
	}
	addPoint(t, vars[tvars]);  
	oldtime=newtime;
	oldH=newH;
	oldM=newM;
	oldS=newS;
	setTimeout("updateChart()", updateInterval)
}

function setvar(v) 
{
	for (var i = 0; i < nvar; i++)
	{
		if (i == v)
			grvars[i].setAttribute("fill", "blue");
		else
			grvars[i].setAttribute("fill", "brown");
	}
	remove();
	tvars=v;
}
function remove()
{
	for(var i = 0; i <nc; i++)
	{
		chartGroup.removeChild(grcircle[i]);
	}
	nc=0;
	ti=0;
	chartGroup.removeChild(dataPath);
	dataPath = documentSVG.createElementNS(svgNS, "path"); 
	dataPath.setAttribute("stroke", "black");
	dataPath.setAttribute("stroke-width", "1");
	dataPath.setAttribute("fill", "none");
	chartGroup.appendChild(dataPath);
	for (var i = 0; i <= xDivisions; i++)
	{
		axisGroup.removeChild(xIndexes[i]);
	}
	if ((oldM + xt2/60)<=60)
	{
		for (var i = 0; i <= xDivisions; i++)
		{
			t = documentSVG.createElementNS(svgNS, "text");
			xIndexes[i] = t;
			t.appendChild(documentSVG.createTextNode((oldH+":"+(oldM+i))));
			t.setAttribute("x", i * width / xDivisions - defaultTextWidth / 2);
			t.setAttribute("y", height + 10 + defaultTextHeight); 
			t.setAttribute("stroke", "black"); 
			axisGroup.appendChild(t);
		}
	}
	else
	{
		for (var i = 0; i < (60-oldM); i++)
		{
			t = documentSVG.createElementNS(svgNS, "text");
			xIndexes[i] = t;
			t.appendChild(documentSVG.createTextNode((oldH+":"+(oldM+i))));
			t.setAttribute("x", i * width / xDivisions - defaultTextWidth / 2);
			t.setAttribute("y", height + 10 + defaultTextHeight); 
			t.setAttribute("stroke", "black"); 
			axisGroup.appendChild(t);
		}
		if(oldH!=23)
		{
			for (var i = (60-oldM); i <= xDivisions; i++)
			{
				t = documentSVG.createElementNS(svgNS, "text");
				xIndexes[i] = t;
				t.appendChild(documentSVG.createTextNode((oldH+1+":"+(i-(60-oldM)))));
				t.setAttribute("x", i * width / xDivisions - defaultTextWidth / 2);
				t.setAttribute("y", height + 10 + defaultTextHeight); 
				t.setAttribute("stroke", "black"); 
				axisGroup.appendChild(t);
			}
		}
		else
		{
			for (var i = (60-oldM); i <= xDivisions; i++)
			{
				t = documentSVG.createElementNS(svgNS, "text");
				xIndexes[i] = t;
				t.appendChild(documentSVG.createTextNode(("0:"+(i-(60-oldM)))));
				t.setAttribute("x", i * width / xDivisions - defaultTextWidth / 2);
				t.setAttribute("y", height + 10 + defaultTextHeight); 
				t.setAttribute("stroke", "black"); 
				axisGroup.appendChild(t);
			}
		}
	}
}

function createfanInfo(x, y, f) 
{
	if (currentNodeInfo) removePointInfo();
	currentNodeInfo = documentSVG.createElementNS(svgNS, "text");
	currentNodeInfo.appendChild(documentSVG.createTextNode(fans[f]));
	currentNodeInfo.setAttribute("x", x);
	currentNodeInfo.setAttribute("y", y);
	chartGroup.appendChild(currentNodeInfo);
}
function createvarInfo(x, y, v) 
{
	if (currentNodeInfo) removePointInfo();
	currentNodeInfo = documentSVG.createElementNS(svgNS, "text");
	currentNodeInfo.appendChild(documentSVG.createTextNode(vars[v]));
	currentNodeInfo.setAttribute("x", x);
	currentNodeInfo.setAttribute("y", y);
	chartGroup.appendChild(currentNodeInfo);
}